:- ['holestrings.pl'].



% FF scenario --------------------------------------------------



disk(disk1). disk(disk2).

sphere(sphere1). sphere(sphere2).

long(str). long(post).

regular(base).

regular(D) :- disk(D).

hole(posth). hole(ring). 

hole(S):-sphere(S).

cannotPass(D,S,[])        :-disk(D),sphere(S).

cannotPass(D,ring,[])     :-disk(D).

cannotPass(base,ring,[]).

cannotPass(base,posth,[]).

cannotPass(base,S,[])	  :- sphere(S).

cannotPass(post,S,[])     :-sphere(S).

cannotPass(post,posth,[]).

cannotPass(S,posth,[])    :-sphere(S).

cannotPass(S,S1,[])       :-sphere(S), sphere(S1).

cannotPass(S,ring,[post]) :-sphere(S).

cannotPass(posth,S,[])    :-sphere(S).

cannotPass(ring,S,[])     :-sphere(S).

cannotPass(H,H,_)		  :- hole(H).

cannotPass(X,H,Z)		  :- Z\=[],getsubset(Z,Y),Y\=Z,cannotPass(X,H,Y),!.

cannotPass(L^ V,H,Z)	  :- long(L), cannotPass(L,H,Z), \+ canPass(L^ V, H,Z).

canPass(a,a,[]).



% INITIAL STATE ------------------------------------------------



initial( [

  holds(linked(str^ -, disk1), true),

  holds(linked(str^ +, disk2), true),

  holds(linked(post^ -, base), true),

  holds(linked(post^ +, posth), true),

  holds(chain(str),[str^ -, sphere1^ +, posth^ +, sphere2^ +, str^ +]),

% holds(chain(str),[str^ -, sphere1^ +, posth^ +, sphere2^ +, posth^ -,str^ +]),

  holds(chain(post),[post^ -, ring^ +, post^ +])

]).



% GOAL ---------------------------------------------------------



is_goal(S) :- crossedBy(ring,[],S).

